## qt-qml-models 0~0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(spatialite LANGUAGES C)

find_package(Qt5 COMPONENTS Core REQUIRED)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

file(GLOB CPPSources *.cpp)
file(GLOB HSources *.h)

add_library(qt-qml-models STATIC ${CPPSources} ${HSources})
target_include_directories(qt-qml-models PUBLIC ./)
target_link_libraries(qt-qml-models PRIVATE Qt5::Core)

=== debian/changelog ===
qt-qml-models (0~0.0-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:52:39 +1100

qt-qml-models (0~0.0-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:44:54 +0000

qt-qml-models (0~0.0-1) unstable; urgency=medium

  * Initial release (Closes: #980131)

 -- Wookey <wookey@debian.org>  Thu, 14 Jan 2021 11:42:37 +0000

=== debian/control ===
Source: qt-qml-models
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Wookey <wookey@debian.org>
Build-Depends: debhelper-compat (= 12), qbs, qtbase5-dev,
 qtbase5-private-dev, qtdeclarative5-dev
Standards-Version: 4.5.1
Homepage: https://github.com/cavewhere/qt-qml-models
Rules-Requires-Root: no

Package: libqtqmlmodels0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Additional list-type data models for QML apps
 This package adds 2 C++ data models to the qml back end, for use by 
 QML applications.
 .
 QQmlObjectListModel : a much nicer way to expose C++ list to QML than
 the quick & dirty QList<QObject*> property. Supports all the strong
 model features of QAbstractListModel while having the simple and well
 know API of QList.
 .
 QQmlVariantListModel : a dead-simple way to create a dynamic C++ list
 of any type and expose it to QML, much better than using a QVariantList
 property.
 .
 This package is the library itself.

Package: libqtqmlmodels-dev 
Architecture: any
Multi-Arch: same
Depends: libqtqmlmodels0 (= ${binary:Version}), ${misc:Depends}
Description: Additional list-type data models for QML apps
 This package adds 2 C++ data models to the qml back end, for use by 
 QML applications.
 .
 QQmlObjectListModel : a much nicer way to expose C++ list to QML than
 the quick & dirty QList<QObject*> property. Supports all the strong
 model features of QAbstractListModel while having the simple and well
 know API of QList.
 .
 QQmlVariantListModel : a dead-simple way to create a dynamic C++ list
 of any type and expose it to QML, much better than using a QVariantList
 property.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

LOGLEVEL = info
ifeq ($(DH_VERBOSE),1)
  LOGLEVEL = debug
endif
ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
  LOGLEVEL = warning
endif

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk

#confgure qt5 generally, not just for configure
export QT_SELECT=5

LIBNAME:=libQtQmlModels
VERSION=$(shell dpkg-parsechangelog -S version | awk '{split($$0,a,"-"); print a[1]}')
PKGCONFDIR:=debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig

%:
	dh $@

# Note that the dpkg-buildflags settings are currently static. We await a
# mechanism to convert them dynamically into Qbs-speak

override_dh_auto_configure:
	qbs-setup-toolchains --settings-dir debian --detect
	qbs-setup-qt --settings-dir debian /usr/bin/qmake deb
	qbs config --settings-dir debian profiles.deb.qbs.installPrefix "usr/"
	qbs config --settings-dir debian profiles.deb.cpp.debugInformation true
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	qbs config --settings-dir debian profiles.deb.cpp.optimization none
else
	qbs config --settings-dir debian profiles.deb.cpp.optimization fast
endif
	qbs config --settings-dir debian profiles.deb.cpp.commonCompilerFlags -Wdate-time
	qbs config --settings-dir debian profiles.deb.cpp.defines '"_FORTIFY_SOURCE=2"'
	qbs config --settings-dir debian profiles.deb.cpp.cFlags '[ "-fdebug-prefix-map=$(CURDIR)=.", "-fstack-protector-strong", "-Wformat", "-Werror=format-security" ]'
	qbs config --settings-dir debian profiles.deb.cpp.cxxFlags '[ "-fdebug-prefix-map=$(CURDIR)=.", "-fstack-protector-strong", "-Wformat", "-Werror=format-security" ]'
	qbs config --settings-dir debian profiles.deb.cpp.linkerFlags "-z,relro"

override_dh_auto_build:
	qbs build --settings-dir debian --log-level $(LOGLEVEL) --command-echo-mode command-line --no-install \
           profile:deb \
           modules.qbs.installRoot:$(CURDIR)/debian/tmp \
           project.libDir:lib/$(DEB_HOST_MULTIARCH) \
           config:qbs-build
        # Generate pkgconfig file
	sed -e "s/@DEB_HOST_MULTIARCH@/${DEB_HOST_MULTIARCH}/;s/@VERSION@/$(VERSION)/" < debian/$(LIBNAME).pc.in > debian/$(LIBNAME).pc

override_dh_auto_install:
	qbs install --settings-dir debian --no-build --log-level $(LOGLEVEL)\
           --install-root $(CURDIR)/debian/tmp \
           project.libDir:lib/$(DEB_HOST_MULTIARCH) \
           profile:deb \
           config:qbs-build
	mkdir -p $(PKGCONFDIR)
	mv debian/$(LIBNAME).pc $(PKGCONFDIR)/$(LIBNAME).pc
	dh_install

override_dh_clean:
	# tidy up qbs profile builddirs
	- rm -r qbs-build
	- rm debian/$(LIBNAME).pc
	- rm -r debian/qbs
	dh_clean
